
#include <alloc.h>
#include <string.h>
#include <stdio.h>
#include <dir.h>

#include <conio.h>

#include "keys.h"

struct thead{
	unsigned char type;
	char name[10];
	unsigned length;
	unsigned start;
	unsigned blen;
};

typedef struct hdr{
	unsigned size;
	unsigned char type;
	struct thead t;
	struct hdr *prev;
	struct hdr *next;
} HDR;

typedef struct trd{
	char name[8];
	char type;
	unsigned start;
	unsigned length;
	unsigned char sex;
	unsigned char sec;
	unsigned char trk;
} TRD;

#define SEC_SIZ		256
#define TRK_SIZ		16

HDR *root = NULL, *top, *bot, *cur;
char typs[] = "BN#C";
char name[MAXPATH];
unsigned count, y;

int read_tap(FILE *f)
{
	HDR *p;
	unsigned len;
	char type;
	int count = 0;

	while(fread(&len,2,1,f)){
		fread(&type,1,1,f);
		if((p = malloc(sizeof(HDR)))==NULL) return count;
		++count;

		if(root) root->next = p;
		p->next = NULL;
		p->prev = root;
		root = p;

		p->size = len-2;
		if(!(p->type = type)){
			fread(&p->t,sizeof(struct thead),1,f);
			fread(&type,1,1,f);
		}
		else
			fseek(f,len-1,SEEK_CUR);
	}

	if(root)
		while(root->prev) root = root->prev;
	cur = top = root;
	y = 1;

	return count;
}


sseek(FILE *f, int sec, int trk)
{
	sec &= 0xFF;
	trk &= 0xFF;
	fseek(f,(long)trk * (long)TRK_SIZ * (long)SEC_SIZ +
		(long)sec * (long)SEC_SIZ, SEEK_SET);
}


read_trd(FILE *f)
{
	TRD tr;
	HDR *p;
	int count = 0;
	long pos;
	char *buff;

	buff = malloc(50000);
	while(1){
		fread(&tr,sizeof(TRD),1,f);
		if(!*tr.name) break;

		if((p = malloc(sizeof(HDR)))==NULL) return count;
		++count;

		if(root) root->next = p;
		p->next = NULL;
		p->prev = root;
		root = p;

		p->type = 0;
		p->size = tr.length;
		p->t.type = tr.type;
		p->t.start = tr.start;
		p->t.blen = p->t.length = tr.length;
		strncpy(p->t.name, tr.name, 8);
		p->t.name[8] = 0;

		if(p->t.type=='B' && buff){
			pos = ftell(f);
			sseek(f, tr.sec, tr.trk);
			fread(buff, 256, tr.sex, f);
			if(*(unsigned int *)(buff + tr.start) == 0xAA80)
				p->t.start = *(unsigned int *)(buff + tr.start + 2);
			fseek(f,pos,SEEK_SET);
		}
	}
	if(root)
		while(root->prev) root = root->prev;
	cur = top = root;
	y = 1;
	return count;
}

draw_line(HDR *p)
{
	if(!p->type){
		if(p == cur)
			textattr(CYAN << 4 | BLACK);
		else if(*p->t.name == 1)
			textattr(BLUE);
		else{
			switch(p->t.type){
				case 'B': case 0 : textattr(WHITE); break;
				case 1 : textattr(LIGHTGREEN); break;
				case 2 : textattr(LIGHTMAGENTA); break;
				case 'C' : case 3 : textattr(YELLOW); break;
				default : textattr(LIGHTCYAN); break;
			}
		}
		cprintf(" %c %-10.10s  %-6u #%4.4X  %-6u #%4.4X  %-6u #%4.4X",
			p->t.type < '0' ? typs[p->t.type] : (char)p->t.type,
			p->t.name,
			p->t.length,
			p->t.length,
			p->t.start,
			p->t.start,
			p->t.blen,
			p->t.blen);
	}
	else{
		if(p == cur)
			textattr(CYAN << 4 | BLACK);
		else
			textattr(BLACK << 4 | CYAN);
		cprintf("    BLOCK  %-6u #%4.4X               ", p->size, p->size);
	}
	clreol();
}

draw_page(struct text_info *txt)
{
	HDR *p;
	int i;

	textattr(BLACK << 4 | CYAN);
	if(!(p = top)) return;
	for(i=1; i<=txt->winbottom-txt->wintop+1; ++i){
		gotoxy(1,i);
		if(p){
			draw_line(p);
			bot = p;
			p = p->next;
		}
	}
}


draw_tap()
{
	struct text_info txt;
	char *tmp;
	int x,y;

	gettextinfo(&txt);
	x = txt.curx;
	y = txt.cury;

	tmp = malloc(txt.screenwidth * txt.screenheight * 2);
	if(tmp)
		gettext(1,1,txt.screenwidth,txt.screenheight,tmp);
	textattr(BLACK << 4 | CYAN);
	clrscr();
	textattr(LIGHTGRAY << 4 | BLACK);
	gotoxy(1,1);
	clreol();
	cprintf("  TAP File viewer by Rick Murray, Version from %s",__DATE__);
	gotoxy(1,txt.screenheight);
	clreol();
	cprintf("  Use arrows, PgUp, PgDown, Home, End, Escape keys for driving");
	textattr(BLACK << 4 | LIGHTGRAY);
	gotoxy(1,2);
	cprintf(" T Name        Length        Start         Basic");
	gotoxy(1,3);
	cprintf(""
			"");

	window(1,4,txt.screenwidth,txt.screenheight-1);
	gettextinfo(&txt);
	top = root;
	draw_page(&txt);
	navigate(&txt);
	if(tmp)
		puttext(1,1,txt.screenwidth,txt.screenheight,tmp);
	free(tmp);
	gotoxy(x,y);
}



navigate(struct text_info *txt)
{
	int i;
	HDR *p;

	while(1){
		textattr(0);
		gotoxy(txt->winright-txt->winleft, txt->winbottom-txt->wintop+1);
		cprintf(" \b");
		switch(getch()){
			case K_DN :
				if(cur != bot){
					p = cur;
					cur = cur->next;
					gotoxy(1,y);
					draw_line(p);
					gotoxy(1,++y);
					draw_line(cur);
				}
				else if(bot->next){
					top = top->next;
					bot = bot->next;
					gotoxy(1,1);
					delline();
					p = cur;
					cur = cur->next;
					gotoxy(1,y-1);
					draw_line(p);
					gotoxy(1,txt->winbottom-txt->wintop+1);
					draw_line(bot);
				}
				break;
			case K_UP :
				if(cur != top){
					p = cur;
					cur = cur->prev;
					gotoxy(1,y);
					draw_line(p);
					gotoxy(1,--y);
					draw_line(cur);
				}
				else if(top->prev){
					top = top->prev;
					bot = bot->prev;
					p = cur;
					cur = cur->prev;
					gotoxy(1,y);
					draw_line(p);
					gotoxy(1,1);
					insline();
					draw_line(top);
				}
				break;
			case K_HOME :
				cur = top = root; y = 1;
				draw_page(txt);
				break;
			case K_END :
				for(top=bot; top->next; top=top->next); bot=top;
				for(i=0; i<txt->winbottom-txt->wintop; ++i){
					if(!top->prev) break;
					top=top->prev;
				}
				cur = bot;
				y = txt->winbottom-txt->wintop+1;
				draw_page(txt);
				break;
			case K_PGDN :
				for(i=0; i<txt->winbottom-txt->wintop; ++i){
					if(!bot->next) break;
					bot=bot->next;
					top=top->next;
					cur=cur->next;
				}
				draw_page(txt);
				break;
			case K_PGUP :
				for(i=0; i<txt->winbottom-txt->wintop; ++i){
					if(!top->prev) break;
					bot=bot->prev;
					top=top->prev;
					cur=cur->prev;
				}
				draw_page(txt);
				break;
			case K_ESC : return;
		}
	}
}



main(int argc, char **argv)
{
	FILE *f;
	char dr[MAXDRIVE], di[MAXDIR], fi[MAXFILE], ex[MAXEXT];

	if(argc < 2){
XIT:
		printf("TAPVIEW - TAP/TRD Files viewer by Rick Murray, "
				"Version from %s\n"
				"Usage:\n"
				"  TAPVIEW <tap file>\n",__DATE__);
		return 1;
	}
	strcpy(name,argv[1]);
	strupr(name);
	fnsplit(name,dr,di,fi,ex);
	if((f = fopen(name,"rb")) == NULL) goto XIT;
	if(strcmp(ex,".TAP") == 0){
		if(!(count = read_tap(f)))
			goto XIT;
	}
	else if(strcmp(ex,".TRD") == 0){
		if(!(count = read_trd(f)))
			goto XIT;
	}
	else
		goto XIT;
	fclose(f);

	draw_tap();
}

